#ifndef RT_VK_PHYSICAL_RESOURCE_MANAGER_H
#define RT_VK_PHYSICAL_RESOURCE_MANAGER_H

#include <runtime/runtime.h>
#include <volk/volk.h>

#define VMA_STATIC_VULKAN_FUNCTIONS 0
#define VMA_DYNAMI_VULKAN_FUNCTIONS 0
#include <vk_mem_alloc.h>

struct rt_vk_device;

typedef struct {
    struct rt_vk_device *dev;
    VmaAllocator allocator;
} rt_vk_physical_resource_manager;

typedef struct {
    rt_result result;
    rt_vk_physical_resource_manager phys_res_mgr;
} rt_create_vk_physical_resource_manager_result;

rt_create_vk_physical_resource_manager_result rtCreateVkPhysicalResourceManager(struct rt_vk_device *dev);

void rtDestroyVkPhysicalResourceManager(rt_vk_physical_resource_manager *phys_res_mgr);

#endif
